# 第一阶段任务五

> 负责：杨金博、叶钧喆

## 任务目标

支持 [syscall vfork](https://www.man7.org/linux/man-pages/man2/vfork.2.html)

## 测试方法

修改 `ulib/axstarry/syscall_entry/test.rs` 中的 `SDCARD_TESTCASES` 常量为：

```rust
pub const SDCARD_TESTCASES: &[&str] = &[
    "./test-vfork-exit-x86_64",
    "./test-vfork-exec-x86_64",
];
```

然后 `make run` 运行测试。也可以将上述常量改为 `busybox sh` 后 `make run`，然后在 Starry 内部命令行中手动运行这两个文件。

正确的输出是

```
Before vfork
Child print something (child).
After vfork (parent)
Before vfork
Child spawn, blocking parent
Child exec done, quitting
Executed by execv, child stop blocking
```

如果输出不全或者语句顺序颠倒，说明可能存在实现问题。详见 `testcases/testsuits-x86_64-linux-musl/` 目录下的测例源代码文件 `test-vfork-exec.c` 和 `test-vfork-exit.c`。