# 第一阶段任务八

> 负责：史昊林、闭浩扬

## 任务目标

支持 [syscall prctl](https://www.man7.org/linux/man-pages/man2/vfork.2.html) 的 `PR_GET_NAME` 功能

## 测试方法

修改 `ulib/axstarry/syscall_entry/test.rs` 中的 `SDCARD_TESTCASES` 常量为 `busybox sh`，然后 `make run` 启动终端，然后输入 `./prctl` 命令运行测试。如成功，会输出 `prctl` 五个字符。

测例的源代码文件在 `testcases/testsuits-x86_64-linux-musl/prctl.c`

## 补充学习

请史昊林同学看一下这些 commit 的内容学习，并回答以下问题：

- [Commit 4fbf](https://github.com/Arceos-monolithic/Starry/commit/4fbf2d6774d4321d14fd3343502d30fdaeed9d8e)：在这个 commit 之前，直接启动运行 `./prctl` 可以输出，但先启动终端 `./busybox sh` 后再运行 `./prctl` 会触发 Page Fault。这个 Bug 为什么产生？它又是怎么修复的？
- [Commit b7faf6f](https://github.com/Arceos-monolithic/Starry/commit/b7faf6fdaa8bf3e0ade579bd7f94e698902aae57)：这个 commit 实现添加了安全检查，并重写了 syscall 实现。
  - 指针不只需要检查是否为空，还需要检查地址是否被分配。哪句代码做了这个检查？
  - 之前只要 name 为空就会触发 Page Fault，现在即使把 name 设置为空串也不会导致这一问题。为什么？是如何解决的？
  - name 的长度被限制在 16 Bytes。为什么会有这个限制？
- [Commit a141ad0](https://github.com/Arceos-monolithic/Starry/commit/a141ad05f63db1d47e9714511e16bd8414e0330c)：这个 commit 更新了参数 Option 的实现，消除了 Warning。
  - 列出编译运行上一个 commit 时出现的每一个 Warning 提示。并且说明，在这个 commit 中，它们分别是如何被解决的。