//! Platform constants and parameters for raspi4-aarch64.
//! Generated by build.rs, DO NOT edit!

/// Stack size of each task.
pub const TASK_STACK_SIZE: usize = 0x40000;
/// Number of timer ticks per second (Hz). A timer tick may contain several timer
/// interrupts.
pub const TICKS_PER_SEC: usize = 100;
/// Architecture identifier.
pub const ARCH: &str = "aarch64";
/// Platform identifier.
pub const PLATFORM: &str = "raspi4-aarch64";
/// Base address of the whole physical memory.
pub const PHYS_MEMORY_BASE: usize = 0x0;
/// Size of the whole physical memory.
pub const PHYS_MEMORY_SIZE: usize = 0xFC00_0000;
/// Base physical address of the kernel image.
pub const KERNEL_BASE_PADDR: usize = 0x8_0000;
/// Base virtual address of the kernel image.
pub const KERNEL_BASE_VADDR: usize = 0xffff_0000_0008_0000;
/// Linear mapping offset, for quick conversions between physical and virtual
/// addresses.
pub const PHYS_VIRT_OFFSET: usize = 0xffff_0000_0000_0000;
/// MMIO regions with format (`base_paddr`, `size`).
pub const MMIO_REGIONS: &[(usize, usize)] = &[
    (0xFE20_1000, 0x1000),
    (0xFF84_1000, 0x8000),
];

pub const VIRTIO_MMIO_REGIONS: &[(usize, usize)] = &[
];
/// UART Address
pub const UART_PADDR: usize = 0xFE20_1000;

pub const UART_IRQ_NUM: usize = 153;
/// GIC Address
pub const GICC_PADDR: usize = 0xFF84_2000;

pub const GICD_PADDR: usize = 0xFF84_1000;
/// Number of CPUs
pub const SMP: usize = 1;
